<?php
namespace app\workerapi\lists;

use app\common\model\tenant\TenantRegister;
use app\common\lists\ListsSearchInterface;
use app\workerapi\logic\SaleLogic;


/**
 * TenantRegister列表
 * Class TenantRegisterLists
 * @package app\workerapi\lists
 */
class TenantRegisterLists extends BaseWorkerDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function setSearch(): array
    {
        $sale_id = SaleLogic::getSaleIdByToken($this->params['sale_token']??'00000');
        $this->params['sale_id'] = $sale_id;
        return [
            '=' => ['door_images', 'business_images', 'province', 'city', 'area_name', 'lon', 'lat', 'status', 'sale_id', 'openid'],
            '%like%' => ['name', 'head_name','mobile'],
        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function lists(): array
    {
        return TenantRegister::with(['sale'])->where($this->searchWhere)
            ->field(['*'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2025/02/25 09:29
     */
    public function count(): int
    {
        return TenantRegister::where($this->searchWhere)->count();
    }

}